// Utilité : permet de modifier les variables de déplacement en fonction des caractres recus sur le port série


// EN ENTREE :
   // Le caractère stocké dans la variable caracRecu

// EN SORTIE :
   // Modification de l'une des variables deplacerVaisseauADroite et deplacerVaisseauAGauche
   
// LANCEMENT :
   // Lancé régulièrement par draw()
   
   
void claculCaractereSerie(){
  //----On teste si on a au moins un port disponible
  if(nbrPortsOuverts>0){
    //---On passe alors en revue tous les ports ouverts
    //---On vérifie que le nombre de port est bien le bon
    verifierNbrPorts();
    for(int i=0;i<nbrPortsOuverts;i++){
      if (caracRecu[i]=='g' || caracRecu[i]=='G'){
        println(i);
        deplacerVaisseauADroiteParSerial=0; 
        deplacerVaisseauAGaucheParSerial=1;
        caracRecu[i]=' ';
        //On etourne au programme principal pour traiter le déplacement
        return;
      }
      else if (caracRecu[i]=='d' || caracRecu[i]=='D'){
        deplacerVaisseauADroiteParSerial=1; 
        deplacerVaisseauAGaucheParSerial=0;
        caracRecu[i]=' ';
        //On etourne au programme principal pour traiter le déplacement
        return;
      }
      else {
        deplacerVaisseauADroiteParSerial=0; 
        deplacerVaisseauAGaucheParSerial=0;
      }
    }
  }
}
   
   
void verifierNbrPorts(){
// Utilité : permet de s'assurer que le nombre de ports est le bon et le change si besoin est

  //-----On commence par charger la liste des ports détectés
  portsOuvertsVerif = Serial.list();
  //-----On détermine le nombre réel de ports ouverts
  nbrPortsOuvertsVerif = portsOuvertsVerif.length;
  println("Il y a "+nbrPortsOuvertsVerif+" ports vérifiés / "+nbrPortsOuverts+" ports ouverts");
  //-----On teste s'il y a une différence entre les 2
  if(nbrPortsOuvertsVerif != nbrPortsOuverts){
    println("Un problème de port a été détecté...");
    //---Il faut gérer le problème de ports
    //---On va détruire tous les ports actuels
    for(int i=0;i<nbrPortsOuverts;i++){
      println("On efface le buffer du port : "+i);
      monPort[i].clear();
      println("On stope le port : "+i);
      monPort[i].stop();
    }
    println("Les ports sont normalement détruits");
    //---On lance un noveau scan en :
      //--Levant le drapeau scanPortsAFaire
      scanPortsAFaire=1;
      //--Pour éviter d'attendre la fin de la boucle pour scanner effectivement les ports :
      //--Pour exécute la fonction de scan des ports
      println("Un scan de port a été lancé...");
      scannerPorts(); 
      //--Le drapeau correspondant à la demande de construction des ports est levé par le scan des ports
      println("Les ports vont à nouveau être initialisés...");
      initialiserPorts();
  }
   
  
  
  
}

   
   


   
   
   
   
   




